searchNodes=[{"doc":"Base module for configuration file. Imports macros for the config DSL and contains functions for working/starting the configuration parsed.","ref":"Ejabberd.Config.html","title":"Ejabberd.Config","type":"module"},{"doc":"Returns a list with all the opts, formatted for ejabberd.","ref":"Ejabberd.Config.html#get_ejabberd_opts/0","title":"Ejabberd.Config.get_ejabberd_opts/0","type":"function"},{"doc":"","ref":"Ejabberd.Config.html#hook/3","title":"Ejabberd.Config.hook/3","type":"macro"},{"doc":"Given the path of the config file, it evaluates it.","ref":"Ejabberd.Config.html#init/2","title":"Ejabberd.Config.init/2","type":"function"},{"doc":"","ref":"Ejabberd.Config.html#listen/2","title":"Ejabberd.Config.listen/2","type":"macro"},{"doc":"","ref":"Ejabberd.Config.html#module/2","title":"Ejabberd.Config.module/2","type":"macro"},{"doc":"Register the hooks defined inside the elixir config file.","ref":"Ejabberd.Config.html#start_hooks/0","title":"Ejabberd.Config.start_hooks/0","type":"function"},{"doc":"Module used to work with the attributes parsed from an elixir block (do...end). Contains functions for extracting attrs from a block and validation.","ref":"Ejabberd.Config.Attr.html","title":"Ejabberd.Config.Attr","type":"module"},{"doc":"Takes a block with annotations and extracts the list of attributes.","ref":"Ejabberd.Config.Attr.html#extract_attrs_from_block_with_defaults/1","title":"Ejabberd.Config.Attr.extract_attrs_from_block_with_defaults/1","type":"function"},{"doc":"Returns the default value for an attribute, given its name.","ref":"Ejabberd.Config.Attr.html#get_default_for_attr/1","title":"Ejabberd.Config.Attr.get_default_for_attr/1","type":"function"},{"doc":"Returns the type of an attribute, given its name.","ref":"Ejabberd.Config.Attr.html#get_type_for_attr/1","title":"Ejabberd.Config.Attr.get_type_for_attr/1","type":"function"},{"doc":"Takes an attribute or a list of attrs and validate them. Returns a {:ok, attr} or {:error, attr, cause} for each of the attributes.","ref":"Ejabberd.Config.Attr.html#validate/1","title":"Ejabberd.Config.Attr.validate/1","type":"function"},{"doc":"","ref":"Ejabberd.Config.Attr.html#t:attr/0","title":"Ejabberd.Config.Attr.attr/0","type":"type"},{"doc":"Module containing functions for manipulating ejabberd hooks.","ref":"Ejabberd.Config.EjabberdHook.html","title":"Ejabberd.Config.EjabberdHook","type":"module"},{"doc":"Register a hook to ejabberd.","ref":"Ejabberd.Config.EjabberdHook.html#start/1","title":"Ejabberd.Config.EjabberdHook.start/1","type":"function"},{"doc":"","ref":"Ejabberd.Config.EjabberdHook.html#t:t/0","title":"Ejabberd.Config.EjabberdHook.t/0","type":"type"},{"doc":"Module used to log validation errors given validated modules given validated modules.","ref":"Ejabberd.Config.EjabberdLogger.html","title":"Ejabberd.Config.EjabberdLogger","type":"module"},{"doc":"Given a list of modules validated, in the form of {:ok, mod} or {:error, mod, errors}, it logs to the user the errors found.","ref":"Ejabberd.Config.EjabberdLogger.html#log_errors/1","title":"Ejabberd.Config.EjabberdLogger.log_errors/1","type":"function"},{"doc":"Module representing a module block in the configuration file. It offers functions for validation and for starting the modules. Warning: The name is EjabberdModule to not collide with the already existing Elixir.Module.","ref":"Ejabberd.Config.EjabberdModule.html","title":"Ejabberd.Config.EjabberdModule","type":"module"},{"doc":"Given a list of modules, it takes only the ones with a git attribute and tries to fetch the repo, then, it install them through :ext_mod.install/1","ref":"Ejabberd.Config.EjabberdModule.html#fetch_git_repos/1","title":"Ejabberd.Config.EjabberdModule.fetch_git_repos/1","type":"function"},{"doc":"Given a list of modules / single module it runs different validators on them. For each module, returns a {:ok, mod} or {:error, mod, errors}","ref":"Ejabberd.Config.EjabberdModule.html#validate/1","title":"Ejabberd.Config.EjabberdModule.validate/1","type":"function"},{"doc":"","ref":"Ejabberd.Config.EjabberdModule.html#t:t/0","title":"Ejabberd.Config.EjabberdModule.t/0","type":"type"},{"doc":"Module for formatting options parsed into the format ejabberd uses.","ref":"Ejabberd.Config.OptsFormatter.html","title":"Ejabberd.Config.OptsFormatter","type":"module"},{"doc":"Takes a keyword list with keys corresponding to the keys requested by the ejabberd config (ex: modules: mods) and formats them to be correctly evaluated by ejabberd. Look at how Config.get_ejabberd_opts/0 is constructed for more informations.","ref":"Ejabberd.Config.OptsFormatter.html#format_opts_for_ejabberd/1","title":"Ejabberd.Config.OptsFormatter.format_opts_for_ejabberd/1","type":"function"},{"doc":"Module used for storing the modules parsed from the configuration file. Example: - Store . put ( :modules , mod1 ) - Store . put ( :modules , mod2 ) - Store . get ( :modules ) :: [ mod1 , mod2 ] Be carefoul: when retrieving data you get them in the order inserted into the store, which normally is the reversed order of how the modules are specified inside the configuration file. To resolve this just use a Enum.reverse/1.","ref":"Ejabberd.Config.Store.html","title":"Ejabberd.Config.Store","type":"module"},{"doc":"Gets a value based on the key passed. Returns always a list.","ref":"Ejabberd.Config.Store.html#get/1","title":"Ejabberd.Config.Store.get/1","type":"function"},{"doc":"Stores a value based on the key. If the key already exists, then it inserts the new element, maintaining all the others. It uses a list for this.","ref":"Ejabberd.Config.Store.html#put/2","title":"Ejabberd.Config.Store.put/2","type":"function"},{"doc":"","ref":"Ejabberd.Config.Store.html#start_link/0","title":"Ejabberd.Config.Store.start_link/0","type":"function"},{"doc":"Stops the store. It uses Agent.stop underneath, so be aware that exit could be called.","ref":"Ejabberd.Config.Store.html#stop/0","title":"Ejabberd.Config.Store.stop/0","type":"function"},{"doc":"Module used to validate a list of modules.","ref":"Ejabberd.Config.Validation.html","title":"Ejabberd.Config.Validation","type":"module"},{"doc":"Given a module or a list of modules it runs validators on them and returns {:ok, mod} or {:error, mod, errors}, for each of them.","ref":"Ejabberd.Config.Validation.html#validate/1","title":"Ejabberd.Config.Validation.validate/1","type":"function"},{"doc":"","ref":"Ejabberd.Config.Validation.html#t:mod_validation/0","title":"Ejabberd.Config.Validation.mod_validation/0","type":"type"},{"doc":"","ref":"Ejabberd.Config.Validation.html#t:mod_validation_result/0","title":"Ejabberd.Config.Validation.mod_validation_result/0","type":"type"},{"doc":"Validator module used to validate attributes.","ref":"Ejabberd.Config.Validator.Attrs.html","title":"Ejabberd.Config.Validator.Attrs","type":"module"},{"doc":"Given a module (with the form used for validation) it runs Attr.validate/1 on each attribute and returns the validation tuple with the errors updated, if found.","ref":"Ejabberd.Config.Validator.Attrs.html#validate/1","title":"Ejabberd.Config.Validator.Attrs.validate/1","type":"function"},{"doc":"","ref":"Ejabberd.Config.Validator.Attrs.html#t:mod_validation/0","title":"Ejabberd.Config.Validator.Attrs.mod_validation/0","type":"type"},{"doc":"Validator module used to validate dependencies specified with the @dependency annotation.","ref":"Ejabberd.Config.Validator.Dependencies.html","title":"Ejabberd.Config.Validator.Dependencies","type":"module"},{"doc":"Given a module (with the form used for validation) it checks if the @dependency annotation is respected and returns the validation tuple with the errors updated, if found.","ref":"Ejabberd.Config.Validator.Dependencies.html#validate/1","title":"Ejabberd.Config.Validator.Dependencies.validate/1","type":"function"},{"doc":"","ref":"Ejabberd.Config.Validator.Dependencies.html#t:mod_validation/0","title":"Ejabberd.Config.Validator.Dependencies.mod_validation/0","type":"type"},{"doc":"Module used as a base validator for validation modules. Imports utility functions for working with validation structures.","ref":"Ejabberd.Config.ValidatorUtility.html","title":"Ejabberd.Config.ValidatorUtility","type":"module"},{"doc":"Given a list of modules it extracts and returns a list of the module names (which are Elixir.Module).","ref":"Ejabberd.Config.ValidatorUtility.html#extract_module_names/1","title":"Ejabberd.Config.ValidatorUtility.extract_module_names/1","type":"function"},{"doc":"Inserts an error inside the errors collection, for the given key. If the key doesn't exists then it creates an empty collection and inserts the value passed.","ref":"Ejabberd.Config.ValidatorUtility.html#put_error/3","title":"Ejabberd.Config.ValidatorUtility.put_error/3","type":"function"},{"doc":"Module containing utility functions for the config file.","ref":"Ejabberd.ConfigUtil.html","title":"Ejabberd.ConfigUtil","type":"module"},{"doc":"Returns true when the config file is based on elixir.","ref":"Ejabberd.ConfigUtil.html#is_elixir_config/1","title":"Ejabberd.ConfigUtil.is_elixir_config/1","type":"function"},{"doc":"","ref":"Ejabberd.Hooks.html","title":"Ejabberd.Hooks","type":"module"},{"doc":"","ref":"Ejabberd.Hooks.html#add/5","title":"Ejabberd.Hooks.add/5","type":"function"},{"doc":"","ref":"Ejabberd.Hooks.html#delete/5","title":"Ejabberd.Hooks.delete/5","type":"function"},{"doc":"","ref":"Ejabberd.Logger.html","title":"Ejabberd.Logger","type":"module"},{"doc":"","ref":"Ejabberd.Logger.html#critical/2","title":"Ejabberd.Logger.critical/2","type":"function"},{"doc":"","ref":"Ejabberd.Logger.html#debug/2","title":"Ejabberd.Logger.debug/2","type":"function"},{"doc":"","ref":"Ejabberd.Logger.html#error/2","title":"Ejabberd.Logger.error/2","type":"function"},{"doc":"","ref":"Ejabberd.Logger.html#info/2","title":"Ejabberd.Logger.info/2","type":"function"},{"doc":"","ref":"Ejabberd.Logger.html#warning/2","title":"Ejabberd.Logger.warning/2","type":"function"},{"doc":"","ref":"Ejabberd.Module.html","title":"Ejabberd.Module","type":"module"},{"doc":"","ref":"Ejabberd.Module.html#depends/2","title":"Ejabberd.Module.depends/2","type":"function"},{"doc":"","ref":"Ejabberd.Module.html#mod_opt_type/1","title":"Ejabberd.Module.mod_opt_type/1","type":"function"},{"doc":"Lists all ejabberd modules and their dependencies. The project must have ejabberd as a dependency.","ref":"Mix.Tasks.Ejabberd.Deps.Tree.html","title":"Mix.Tasks.Ejabberd.Deps.Tree","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1 .","ref":"Mix.Tasks.Ejabberd.Deps.Tree.html#run/1","title":"Mix.Tasks.Ejabberd.Deps.Tree.run/1","type":"function"},{"doc":"","ref":"ModPresenceDemo.html","title":"ModPresenceDemo","type":"module"},{"doc":"Callback implementation for :gen_mod.depends/2 .","ref":"ModPresenceDemo.html#depends/2","title":"ModPresenceDemo.depends/2","type":"function"},{"doc":"Callback implementation for :gen_mod.mod_doc/0 .","ref":"ModPresenceDemo.html#mod_doc/0","title":"ModPresenceDemo.mod_doc/0","type":"function"},{"doc":"Callback implementation for :gen_mod.mod_options/1 .","ref":"ModPresenceDemo.html#mod_options/1","title":"ModPresenceDemo.mod_options/1","type":"function"},{"doc":"","ref":"ModPresenceDemo.html#on_presence/4","title":"ModPresenceDemo.on_presence/4","type":"function"},{"doc":"Callback implementation for :gen_mod.start/2 .","ref":"ModPresenceDemo.html#start/2","title":"ModPresenceDemo.start/2","type":"function"},{"doc":"Callback implementation for :gen_mod.stop/1 .","ref":"ModPresenceDemo.html#stop/1","title":"ModPresenceDemo.stop/1","type":"function"}]